/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.scalar.conf 11805 2005-01-07 09:37:18Z dts12 $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "nastest.h"
#include<stdio.h>
#include<string.h>
#include<errno.h>

int temp_disp = 0;

/** Initializes the nastest module */
void
init_nastest(void)
{
    static oid temperature_oid[] = { 1,3,6,1,4,1,65535,1 };
    static oid temp_display_oid[] = { 1,3,6,1,4,1,65535,2 };

  DEBUGMSGTL(("nastest", "Initializing\n"));

    netsnmp_register_scalar(
        netsnmp_create_handler_registration("temperature", handle_temperature,
                               temperature_oid, OID_LENGTH(temperature_oid),
                               HANDLER_CAN_RONLY
        ));

    netsnmp_register_scalar(
        netsnmp_create_handler_registration("temp_display", handle_temp_display,
                               temp_display_oid, OID_LENGTH(temp_display_oid),
                               HANDLER_CAN_RWRITE
        ));
}

int
handle_temperature(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
	    char result[256];
	    u_char* cp = NULL;
	    FILE* fd;
    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
	    if (temp_disp) {
		    fd = popen("/usr/local/sbin/miconapl -a temp_get", "r");
		    if (fd == NULL) {
			    snprintf(result, 255, "%s", strerror(errno));
			    cp = result;
		    }
		    while (!cp) {
			    if (fgets(result, 256, fd) == NULL) {
				    snprintf(result, 255, "%s", strerror(errno));
				    cp = result;
			    }
			    else if (strncmp(result, "err:", 4) == 0)
				    cp = result;
			    else if (strncmp(result, "temp=", 5) == 0)
				    cp = &result[5];
		    }
		    pclose(fd);
		    snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
					     (u_char *) cp, strlen(cp));
	    }
            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_temperature\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

int handle_temp_display(netsnmp_mib_handler *handler,
			netsnmp_handler_registration *reginfo,
			netsnmp_agent_request_info *reqinfo,
			netsnmp_request_info *requests)
{
	int ret;

	switch (reqinfo->mode) {
	case MODE_GET:
		snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
					 (u_char*)&temp_disp, sizeof(temp_disp));
		break;
	case MODE_SET_RESERVE1:
		ret = netsnmp_check_vb_type(requests->requestvb, ASN_INTEGER);
		if (ret != SNMP_ERR_NOERROR) {
			netsnmp_set_request_error(reqinfo, requests, ret);
		}
		break;
	case MODE_SET_ACTION:
		temp_disp = *(requests->requestvb->val.integer);
		break;
	case MODE_SET_RESERVE2:
	case MODE_SET_FREE:
	case MODE_SET_COMMIT:
	case MODE_SET_UNDO:
		break;
	default:
		snmp_log(LOG_ERR, "unknown mode (%d) in handle_temp_display\n",
			 reqinfo->mode);
		return SNMP_ERR_GENERR;
	}

	return SNMP_ERR_NOERROR;
}
